apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: docker-build-dind
  namespace: {{ buildns }}
spec:
  params:
  - default: {{ tekton_docker_builder_image }}
    description: The location of the Docker builder image.
    name: builderimage
    type: string
  - default: {{ tekton_docker_dind_image }}
    description: The location of the Docker in Docker image.
    name: dindimage
    type: string
  - name: dstimage
    description: Where to push the resulting image
    type: string
  - default: ""
    description: Optional Password or Token cloning sources during the image build process.
    name: clonepass
    type: string
  - default: ""
    description: Optional Username cloning sources during the image build process.
    name: cloneuser
    type: string
  - default: Dockerfile
    description: The name of the Dockerfile
    name: dockerfile
    type: string
  - default: .
    description: Docker build context path
    name: dockerroot
    type: string
  - default: ""
    description: Forces USER in Dockerfile - either a specific uid, or any string would translate to {{ k8s_unprivileged_userid }}.
    name: forceuid
    type: string
  - default: ""
    description: Forces first FROM in Dockerfile.
    name: frombuilder
    type: string
  - default: ""
    description: Forces last FROM in Dockerfile.
    name: fromimage
    type: string
  - default: "{{ docker_registry }}"
    description: When pulling/pushing from insecure registries, set its address here
    name: insecure
    type: string
  - default: VERSION
    description: Version ARG name
    name: versionarg
    type: string
  - default: ""
    description: Version ARG value
    name: versionval
    type: string
  results:
  - description: Digest of the image just built.
    name: IMAGE_DIGEST
  steps:
  - command:
    - /bin/sh
    - -c
    - |
        if test "$(params.frombuilder)"; then \
            REPLACE=`awk '/FROM /{print $2}' "$(params.dockerroot)/$(params.dockerfile)" | head -1`; \
{% if k8s_flavor == 'kubernetes' %}
            if echo "$(params.frombuilder)" | grep -E '/.*/' >/dev/null; then \
                WITH="$(params.frombuilder)"; \
            else \
                WITH="{{ docker_registry }}/{{ buildns }}/$(params.frombuilder)"; \
            fi; \
{% else %}
            WITH="$(params.frombuilder)"; \
{% endif %}
            sed -i "s|^[ ]*FROM[ ]*$REPLACE|FROM $WITH|" "$(params.dockerroot)/$(params.dockerfile)"; \
        fi; \
        if test "$(params.fromimage)"; then \
            REPLACE=`awk '/FROM /{print $2}' "$(params.dockerroot)/$(params.dockerfile)" | tail -1`; \
{% if k8s_flavor == 'kubernetes' %}
            if echo "$(params.fromimage)" | grep -E '/.*/' >/dev/null; then \
                WITH="$(params.fromimage)"; \
            else \
                WITH="{{ docker_registry }}/{{ buildns }}/$(params.fromimage)"; \
            fi; \
{% else %}
            WITH="$(params.fromimage)"; \
{% endif %}
            sed -i "s|^[ ]*FROM[ ]*$REPLACE|FROM $WITH|" "$(params.dockerroot)/$(params.dockerfile)"; \
        fi; \
        if test "$(params.forceuid)" -a "$(params.forceuid)" -gt 0 >/dev/null 2>&1; then \
            if ! grep -E '^USER[ \t]*[0-9]' "$(params.dockerroot)/$(params.dockerfile)" >/dev/null; then \
                echo USER $(params.forceuid) >>"$(params.dockerroot)/$(params.dockerfile)"; \
            fi; \
        elif test "$(params.forceuid)"; then \
            if ! grep -E '^USER[ \t]*[0-9]' "$(params.dockerroot)/$(params.dockerfile)" >/dev/null; then \
                echo USER {{ k8s_unprivileged_userid }} >>"$(params.dockerroot)/$(params.dockerfile)"; \
            fi; \
        fi; \
{% if has_syncd_images %}
        find /localimagesconfig -name '*.conf' -type f 2>/dev/null | while read f; \
            do \
                while read sourcereg sourceimg targetreg targetimg; \
                do \
                    if test -z "$sourcereg" -o -z "$sourceimg" -o -z "$targetreg" -o -z "$targetimg"; then \
                        echo "Skipping invalid entry $sourcereg/$sourceimg/$targetreg/$targetimg"; \
                        continue; \
                    fi; \
                    if test "$sourcereg" = internal; then \
                        sourcereg={{ docker_registry }}; \
                    fi; \
                    if test "$targetreg" = internal; then \
                        targetreg={{ docker_registry }}; \
                    fi; \
                    sedfrom="$sourcereg/$sourceimg"; \
                    sedto="$targetreg/$targetimg"; \
                    if grep -E "FROM[ ]*$sedfrom[ \t]$" "$(params.dockerroot)/$(params.dockerfile)" >/dev/null 2>&1; then \
                        echo "Applying $sedfrom => $sedto"; \
                        sed -i "s|FROM[ ]*$sedfrom|FROM $sedto|" "$(params.dockerroot)/$(params.dockerfile)"; \
                    fi; \
                done <$f; \
            done || echo done; \
{% endif %}
        if test "$(params.versionval)"; then \
            echo "Forcing $(params.versionarg)=$(params.versionval)"; \
            sed -i "s|$(params.versionarg)=.*|$(params.versionarg)=$(params.versionval)|" "$(params.dockerroot)/$(params.dockerfile)"; \
        fi
    image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
    name: patch-from
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
{% if has_syncd_images %}
    volumeMounts:
    - mountPath: /localimagesconfig
      name: sync-img-config
{% else %}
    volumeMounts: []
{% endif %}
    workingDir: "$(workspaces.source.path)"
  - command:
    - /bin/sh
    - -c
    - |
        docker build --no-cache \
            --build-arg "DO_UPGRADE=true" \
            --build-arg "SRC_CLONE_PASS=$(params.clonepass)" \
            --build-arg "SRC_CLONE_USER=$(params.cloneuser)" \
            -f $(params.dockerfile) \
            -t $(params.dstimage) \
            $(params.dockerroot)
    env:
    - name: DOCKER_HOST
      value: tcp://127.0.0.1:2376
    - name: DOCKER_TLS_VERIFY
      value: '1'
    - name: DOCKER_CERT_PATH
      value: /certs/client
{% if proxy_host | default(False) %}
    - name: http_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: https_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: HTTPS_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
    - name: http_proxy
      value: {{ squid_address }}
    - name: https_proxy
      value: {{ squid_address }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: {{ squid_address }}
    - name: HTTPS_PROXY
      value: {{ squid_address }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
    - name: http_proxy
      value: ""
    - name: https_proxy
      value: ""
    - name: no_proxy
      value: ""
    - name: HTTP_PROXY
      value: ""
    - name: HTTPS_PROXY
      value: ""
    - name: NO_PROXY
      value: ""
{% endif %}
    image: $(params.builderimage)
    name: build
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_build_cpu_limit }}"
        memory: {{ tekton_docker_build_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_build_cpu_request }}"
        memory: {{ tekton_docker_build_memory_request }}
{% else %}
    resources: {}
{% endif %}
    volumeMounts:
    - mountPath: /certs/client
      name: dind-certs
    workingDir: "$(workspaces.source.path)"
  - command:
    - /bin/sh
    - -c
    - |
        docker push $(params.dstimage)
        IMGMATCH=`echo $(params.dstimage) | cut -d: -f1`
        IMGREF=`docker images | grep $IMGMATCH | awk '{print $3}' | head -1`
        docker inspect $IMGREF | awk -F '"' '/Id/{print $4}' >$(workspaces.source.path)/image-digest
    name: push
    image: $(params.builderimage)
    env:
    - name: DOCKER_HOST
      value: tcp://127.0.0.1:2376
    - name: DOCKER_TLS_VERIFY
      value: '1'
    - name: DOCKER_CERT_PATH
      value: /certs/client
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_push_cpu_limit }}"
        memory: {{ tekton_docker_push_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_push_cpu_request }}"
        memory: {{ tekton_docker_push_memory_request }}
{% else %}
    resources: {}
{% endif %}
    volumeMounts:
    - mountPath: /certs/client
      name: dind-certs
  - args:
    - -c
    - |
{% if do_debugs %}
        set -x;
        ls $(workspaces.source.path)
        cat $(workspaces.source.path)/image-digest || echo no digest
{% endif %}
        cat $(workspaces.source.path)/image-digest | tee $(results.IMAGE_DIGEST.path)
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
    name: digest-to-results
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_scripts_cpu_limit }}"
        memory: {{ tekton_scripts_memory_limit }}
      requests:
        cpu: "{{ tekton_scripts_cpu_request }}"
        memory: {{ tekton_scripts_memory_request }}
{% else %}
    resources: {}
{% endif %}
  sidecars:
  - args:
    - --storage-driver=vfs
    - --userland-proxy=false
{% if do_debugs %}
    - --debug
{% endif %}
    - --insecure-registry=$(params.insecure)
    env:
    - name: DOCKER_TLS_CERTDIR
      value: /certs
    image: $(params.dindimage)
    name: dind
    readinessProbe:
      periodSeconds: 1
      exec:
        command:
        - ls
        - /certs/client/ca.pem
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_dind_cpu_limit }}"
        memory: {{ tekton_docker_dind_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_dind_cpu_request }}"
        memory: {{ tekton_docker_dind_memory_request }}
{% else %}
    resources: {}
{% endif %}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /certs/client
      name: dind-certs
  volumes:
  - name: dind-certs
    emptyDir: {}
{% if has_syncd_images %}
  - configMap:
      name: sync-images-tag
    name: sync-img-config
{% endif %}
  workspaces:
  - name: source
